
function popoutCarton(carton) 
	storeData("touchedCarton", carton);
	local editor = getParent().getParent().getEditor();
	
	local unausgepackt = retrieveData("storage"); -- items aus dem storage holen
	local ausgepackt = editor.getPrototypeByName( unausgepackt[1] ); -- das erste getPrototypen
	
	if (ausgepackt) then
		editor.setMode(Editor.BUY_MODE);
		--print ("===="..getRoot().getChild("gui").getName() );--getRoot();--.getChild("gui").modeGroup.setState(5);
		getRoot().getChild("gui").lifeGroup.setState(5);
		
		local selectedObject = editor.selectPrototype(ausgepackt,true);
		if (selectedObject) then
			storeStateObject("selectedObject", selectedObject);
		end
		
		-- shall not be sold for money
		selectedObject.setHasPrice(false);
--				setState("placeMe");
	end	
end


function cleanupCarton()
	-- den zuletzt ausgepacken Karton holen
	local objectID = tonumber(retrieveData("touchedCarton"));
	local object = getParent().getStateObjectFromID(objectID);
	
	if (object) then -- sofern es den ueberhaupt gibt
		print("########### kille Karton: "..objectID);
		object.deleteGameObject(); -- ihn killen
		storeData("touchedCarton", nil); -- und vermerken dass er weg ist
	
		-- restore the price
		local selectedObject = retrieveStateObject("selectedObject");
		if (selectedObject) then
			selectedObject.setHasPrice(true);
		end
		removeStateObject("selectedObject");
	
		-- somit also das item auch aus der Auspack-liste geschmissen werden kann
		local unausgepackt = retrieveData("storage"); -- items aus dem storage holen
		tremove(unausgepackt, 1); -- und aus der liste entfernen
		if (unausgepackt[1]) then -- wenn noch welche drin sind
			storeData("storage", unausgepackt); -- die liste zurueckschreiben
			return true;
		else -- ansonsten bleibt immer das letzte element mindestens drin
			return false; -- aber es wird angezeigt dass es das letzte is
		end
	end;
	
	return true;
end




beginStateMachine()

	-- called when questor builds up all known questScripts
	onEnter(function(msg)
		print ("questMoveIn entered");
		
		--sendMsgThis("questreset");

		storeData("storage", {"CoffeeTableOldschool", "TelephoneOldschool", "LampTableOldschool",
			"ChairKitchenOldschool", "tvOldschool", "TrashCanOldschool", "FlowerBluePot"});
		setState("initial");
	end )
	
	-- on game over: relationship conditions get reset to 0 and all quests are reset to initial
	onMsg("questreset", function(msg)
		-- do not reset this quest since there are no new cartons
		--storeData("storage", {"CoffeeTableOldschool", "TelephoneOldschool", "LampTableOldschool",
		--	"FlowerBluePot", "tvOldschool", "TrashCanOldschool", "ChairKitchenOldschool"});
		--setState("initial");
	end ) 
---------------------------------------------------------------------------------------------------------------------------------------	
	
	state("initial") 
		onMsg("checkCondition", function(msg)
			
		end )
		
		onMsg("unpacked", function(msg)
			--setState("moveIn0");
			--sendMsgThis("unpacked", msg.data);
			
			--getParent().hideGui();
		
			popupConversation(
				"dialogTutMI1"
				--"Linda::Ach, was fr eine Unordnung! Vielleicht sollte ich einfach ein wenig auspacken. Er wird sich sicher freuen, wenn ich ihm helfe und meinen guten Geschmack in puncto Einrichtung unter Beweis stelle.:;"..
				--"Nobody::<<Das Spiel befindet sich jetzt im Baumodus. Ausgepackte Gegenstnde lassen sich mit der Maus durch Linksklick in der Wohnung platzieren. Wenn das Mbel dabei rot leuchtet, bedeutet das, dass es an diesem Ort nicht abgesetzt werden kann. Probiere es aus.>>:;"
				);
			setState("moveIn0");
			storeData("firstCarton", msg.data);
		end )
		
	state("moveIn0")	
		onMsg("yes", function(msg)
			popoutCarton( retrieveData("firstCarton") );
			setState("moveIn1");
		end )
		
	state("moveIn1")
		onMsg("placed", function(msg)
			cleanupCarton();
			storeData("placedObject", msg.sender );
			
			setState("moveIn3");
			popupConversation(
				"dialogTutMI2"
				--"Nobody::<<Man kann einmal platzierte Gegenstnde auch wieder aufgreifen. Ein Linksklick nimmt sie, ein weiterer Linksklick setzt sie wieder ab.>>:;"..
				--"Nobody::<<Wenn die Mbel gedreht werden sollen, muss die linke Maustaste dauerhaft gehalten werden. Probiere es aus, indem du das Mbelstck zunchst durch Linksklick wieder aufnimmst. Dann drckst du erneut auf die linke Maustaste und hltst sie gedrckt>>:;"
			);
			--getParent().showGui();
		end )
		
		onMsg("unpacked", function(msg)
			setState("moveIn");
			sendMsgThis("unpacked",msg.data);
		end )		
		
	state("moveIn3")
		onMsg("placed", function(msg)
			setState("moveIn");
			if ( msg.sender == retrieveData("placedObject") ) then
				popupConversation(
					"dialogTutMI3"
					--"Nobody::<<Du kannst den Baumodus jederzeit verlassen, indem du auf den Button 'Bedrfnisse' klickst. Damit kehrst du in den Normalmodus des Spiels zurck um weitere Kartons auszupacken>>:;"
				);
			else 
				setState("moveIn");
			end
		end )
		
		onMsg("unpacked", function(msg)
			setState("moveIn");
			sendMsgThis("unpacked",msg.data);
		end )
		

	
	state("moveIn")
		onMsg("unpacked", function(msg)
			popoutCarton(msg.data);
		end )

		onMsg("placed", function(msg)
			if (not cleanupCarton()) then
				setState("done");
				sendMsgThis("fertig",msg.data);
			end
		end )

--	state("placeMe")
--		onMsg("placed", function(msg)			
--			getParent().getParent().getEditor().setMode(Editor.LIFE_MODE);
--			setState("moveIn");
--		end )		


---------------------------------------------------------------------------------------------------------------------------------------	

		
	state("done")
		onMsg("fertig", function(msg)
			getParent().getParent().getEditor().setMode(Editor.LIFE_MODE);
			getRoot().getChild("gui").lifeGroup.setState(1);
			sendDelayedMsgThis("ganzFertig", 2000, "");
		end )
		
		onMsg("ganzFertig", function(msg)
			popupConversation(
				"dialogTutMI4"
				--"Nobody::<<Gut gemacht, alle Gegenstnde sind jetzt ausgepackt. Du kannst jederzeit selber in den Baumodus wechseln, wenn du weitere Mbel kaufen mchtest.>>:;"
			);
		end )

	
	-- sackgasse hier
		
endStateMachine()




			


